#define KANJI_DEFAULT_FONT "Ryumin-Light-H"
#define ASCII_DEFAULT_FONT "Times-Roman"
#define TITLE_DEFAULT_FONT "Times-Bold"
#define MONTH_DEFAULT_FONT "Times-Roman"
#define JTITLE_DEFAULT_FONT "Ryumin-Light-H"
#define JTITLE_OLD_DEFAULT_FONT "GothicBBB-Medium-H"
#define DAYNUM_DEFAULT_FONT "Helvetica-Bold"
#define YOUBI_DEFAULT_FONT "GothicBBB-Medium-H"

static char *pheader[] = {
  "%%Title: kpcal (Ver 2.0)",
  "%%Creator: urushima@secom.co.jp",
  "%%CreationDate: Tue Jan  9 10:19:56 1990",
  "%%For: PostScript program to draw the calendar",
  "%%Pages: 2",
  "%%EndComments",
  "",
  "%% Copyright(C) 1987 by Patrick Wood & Pipline Associates, Inc.",
  "%% Permission is granted to modify and distribute this free of charge.",
  "",
  "%% -*-Kanji PostScript Calendar-*-",
  "%%    creator: urushima@secom.co.jp (Kenji Urushima)",
  "%%",
  "%% Special thanks to ..",
  "%%   rihei@inagaki.nuie.nagoya-u.ac.jp",
  "%%   naota@ouics1.ics.osaka-u.ac.jp (Hajime Naota)",
  "%%   kogure@att.co.jp (Hiro Kogure)",
  "%%",
  "",
  "%------ Composite Font define procedure (thanks to rihei) ----",
  "/defineCompFont",
  "{",
  "  /kanjifont exch def",
  "  /asciifont exch def",
  "  /compfont exch def",
  "",
  "  12 dict begin",
  "    /FontName compfont def",
  "    /FontType 0 def",
  "    /WMode 0 def",
  "    /FMapType 3 def",
  "    /FontMatrix matrix def",
  "    /Encoding [0 1] def",
  "    /FDepVector [ asciifont findfont kanjifont findfont ] def",
  "    FontName currentdict",
  "  end",
  "  definefont pop",
  "} def",
  "%---------- Prologue -------------------------------------",
  "/gatu <376e> def",
  "/month_names_old [ <4b53 376e> <4721 376e> <4c6f 4038> <312c 376e> <3b29  376e> <3f65  4c35  376e>",
  "                   <4a38 376e>  <4d55 376e> <4439  376e>  <3f40 4c35 376e> <417a 376e>  <3b55  4176>] def",
  "",
  "/defineholiday {",
  "  /holidays [",
  "   []        % NONE",
  "   [ 1 year 2000 ge { 15 year 1 1 startday dup 1 le { 6 add sub } { 1 sub sub } ifelse } { 15 } ifelse ]  % January",
  "   [ 11 ]    % February",
  "   [ year 1980 ge year 2099 le and { 20.8431 0.242194 year 1980 sub mul year 1980 sub 4 div cvi sub add cvi } { 21 } ifelse]    % March",
  "   [ 29 ]    % April",
  "   [ 3 4 5 ] % May",
  "   []        % June",
  "   [ year 2003 ge { 22 year 7 1 startday dup 1 le { 6 add sub } { 1 sub sub } ifelse } { 20 } ifelse ]        % July",
  "   [ 11 ]        % Auguest",
  "   [ year 2003 ge { 22 year 9 1 startday dup 1 le { 6 add sub } { 1 sub sub } ifelse } { 15 } ifelse",
  "     year 1980 ge year 2099 le and { 23.2488 0.242194 year 1980 sub mul year 1980 sub 4 div cvi sub add cvi } { 23 } ifelse",
  "     4 { 1 index } repeat sub abs 2 eq { add 2 div cvi } { pop pop } ifelse ] % September",
  "   [ year 2000 ge { 10 year 10 1 startday dup 1 le { 1 add sub } { 6 exch sub add } ifelse } { 10 } ifelse ]    % October",
  "   [ 3 23 ]  % November",
  "   [ 23 ]    % December",
  "  ] def",
  "} def",
  "",
  "/daymap 32 array def",
  "",
  "/numbuf 3 string def",
  "",
  "/prtnum { 3 string cvs show} def",
  "",
  "/drawgrid {      % draw calendar boxes",
  "  youbifont findfont 10 scalefont setfont",
  "  0 1 6 {",
  "    dup dup 100 mul 40 moveto",
  "    [<467c 4d4b 467c> <376e 4d4b 467c> <3250 4d4b 467c> <3f65 4d4b 467c> <4c5a 4d4b 467c> <3662 4d4b 467c> <455a 4d4b 467c>  ] exch get",
  "    100 center",
  "    100 mul 35 moveto",
  "    1.0 setlinewidth",
  "    0 1 5 {",
  "      gsave",
  "      100 0 rlineto",
  "      0 -80 rlineto",
  "      -100 0 rlineto",
  "      closepath stroke",
  "      grestore",
  "      0 -80 rmoveto",
  "    } for",
  "  } for",
  "} def",
  "",
  "/drawnums {       % place day numbers on calendar",
  "  dayfont findfont 30 scalefont setfont",
  "  /start year month 1 startday def",
  "  /days ndays def",
  "  start 100 mul 5 add 10 rmoveto",
  "  submonth 0 eq {",
  "    1 1 days {",
  "      daymap exch dup",
  "      start add 7 mod",
  "      dup 1 eq {",
  "        pop 2 % Sunday",
  "      }",
  "      {",
  "        0 eq { 1 } { 0 } ifelse % Saturday / Weekday",
  "      } ifelse",
  "      put",
  "    } for",
  "    holidays month get {",
  "      dup daymap exch get 2 eq {",
  "        1 add",
  "      } { } ifelse",
  "      daymap exch 2 put",
  "    } forall",
  "  }",
  "  {",
  "    1 1 days {",
  "      daymap exch 0 put",
  "    } for",
  "  } ifelse",
  "  1 1 days {",
  "    /day exch def",
  "    gsave",
  "    daymap day get dup 2 eq {",
  "      pop",
  "      currentpoint moveto",
  "      day numbuf cvs false charpath ",
  "      stroke",
  "    }",
  "    {",
  "      1 eq {",
  "        .8 setgray",
  "      } if",
  "      day numbuf cvs show",
  "    } ifelse",
  "    grestore",
  "    day start add 7 mod 0 eq",
  "    {",
  "      currentpoint exch pop 80 sub 5 exch moveto",
  "    }",
  "    {",
  "      100 0 rmoveto",
  "    } ifelse",
  "  } for",
  "} def",
  "",
  "/drawfill {         % place fill squares on calendar",
  "  /start year month 1 startday def",
  "  /days ndays def",
  "  0 35 rmoveto",
  "  1.0 setlinewidth",
  "  0 1 start 1 sub {",
  "    gsave",
  "    .9 setgray",
  "    100 0 rlineto",
  "    0 -80 rlineto",
  "    -100 0 rlineto",
  "    closepath fill",
  "    grestore",
  "    100 0 rmoveto",
  "  } for",
  "  submonth 1 eq",
  "  {",
  "    /lastday 42 def",
  "    600 -365 moveto",
  "  }",
  "  {",
  "    /lastday 40 def",
  "    400 -365 moveto",
  "  } ifelse",
  "  lastday -1 ndays start 1 add add",
  "  {",
  "    /day exch def",
  "    gsave",
  "    .9 setgray",
  "    100 0 rlineto",
  "    0 -80 rlineto",
  "    -100 0 rlineto",
  "    closepath fill",
  "    grestore",
  "    day 7 mod 1 eq",
  "    {",
  "      600 -365 80 add moveto",
  "    }",
  "    {",
  "      -100 0 rmoveto",
  "    } ifelse",
  "  } for",
  "} def",
  "",
  "/isleap {                    % is this a leap year?",
  "  year 4 mod 0 eq            % multiple of 4",
  "  year 100 mod 0 ne          % not century",
  "  year 400 mod 0 eq or and",
  "} def",
  "",
  "/days_month [ 31 28 31 30 31 30 31 31 30 31 30 31 ] def",
  "",
  "/ndays {                     % number of days in this month",
  "  days_month month 1 sub get",
  "  month 2 eq                 % Feb",
  "  isleap and",
  "  {",
  "    1 add",
  "  } if",
  "} def",
  "",
  "/startday {    % starting day-of-week for this month",
  "  /_d exch def  % day",
  "  /_m exch def  % month",
  "  /_y exch def  % year",
  "  _m 2 le {",
  "    /mm _m 12 add def /yy _y 1 sub def",
  "  } {",
  "    /mm _m def /yy _y def",
  "  } ifelse",
  "  /yy1 yy 100 div truncate cvi def",
  "  /yy2 yy yy1 100 mul sub cvi def",
  "  /off yy2 yy2 4 idiv add",
  "  yy1 4 idiv add",
  "  26 mm 1 add mul 10 idiv add",
  "  2 yy1 mul sub",
  "  _d add",
  "  7 mod",
  "  def",
  "  off 0 le {",
  "    /off off 7 add def",
  "  } if",
  "  off 1 sub   % 0--Sunday, 1--monday, etc.",
  "} def",
  "",
  "/center {                   % center string in given width",
  "  /width exch def",
  "  /str exch def width str ",
  "  stringwidth pop sub 2 div 0 rmoveto str show",
  "} def",
  "",
  "/calendar",
  "{",
  "  gsave",
  "  jtitlefont findfont 48 scalefont setfont",
  "  0 60 moveto",
  "  monthfont findfont 50 scalefont setfont",
  "  /monthstring month 10 string cvs def",
  "  50 monthstring stringwidth pop sub 60 moveto",
  "  monthstring show",
  "  jtitlefont findfont 48 scalefont setfont",
  "  gatu show",
  "  jtitlefont_old findfont 30 scalefont setfont",
  "  /month_name_old month_names_old month 1 sub get def",
  "  120 60 moveto",
  "  month_name_old show",
  "  grestore",
  "  titlefont findfont 48 scalefont setfont",
  "  /yearstring year 10 string cvs def",
  "  700 yearstring stringwidth pop sub 60 moveto",
  "  yearstring show",
  "  0 0 moveto",
  "  drawnums",
  "  0 0 moveto",
  "  drawfill",
  "  0 0 moveto",
  "  drawgrid",
  "} def",
  "",
  "/daytext {",
  "  /CompTextFont findfont 6 scalefont setfont",
  "  /mytext exch def",
  "  /myday exch def",
  "  year month 1 startday myday 1 sub add dup 7 mod 100 mul 5 add % gives column",
  "  exch 7 idiv -80 mul % gives row",
  "  dup /ypos exch def moveto",
  "  /LM currentpoint pop def /RM LM 95 add def",
  "  mytext { show crlf } forall",
  "} def",
  "",
  "/crlf {",
  "  ypos 8 sub /ypos exch def LM ypos moveto",
  "} def",
  "/prstr {",
  "  dup stringwidth pop currentpoint pop",
  "  add RM gt {crlf} if show",
  "} def",
  "",
  "/printmonth {",
  "  90 rotate",
  "  50 -120 translate",
  "  /submonth 0 def",
  "  calendar",
  "  month 1 sub 0 eq",
  "  {",
  "    /lmonth 12 def",
  "    /lyear year 1 sub def",
  "  }",
  "  {",
  "    /lmonth month 1 sub def",
  "    /lyear year def",
  "  } ifelse",
  "  month 1 add 13 eq",
  "  {",
  "    /nmonth 1 def",
  "    /nyear year 1 add def",
  "  }",
  "  {",
  "    /nmonth month 1 add def",
  "    /nyear year def",
  "  } ifelse",
  "  /savemonth month def",
  "  /saveyear year def",
  "  /submonth 1 def",
  "  /year lyear def",
  "  /month lmonth def",
  "  gsave",
  "  500 -365 translate",
  "  gsave",
  "  .138 .138 scale",
  "  10 -120 translate",
  "  calendar",
  "  grestore",
  "  /submonth 1 def",
  "  /year nyear def",
  "  /month nmonth def",
  "  100 0 translate",
  "  gsave",
  "  .138 .138 scale",
  "  10 -120 translate",
  "  calendar",
  "  grestore",
  "  /month savemonth def",
  "  /year saveyear def",
  "  /submonth 0 def",
  "  grestore",
  "} def",
  "%--------------- Script --------------------------%",
  (char *) 0,
};

